<template>
  <form class="form" @submit="onSubmit">
    <TextField v-model="name" inputType="text" :error="nameError" id="name" label="نام و نام خانوادگی" />
    <TextField v-model="email" inputType="email" :error="emailError" id="email" label="ایمیل" />
    <TextArea v-model="message" id="message" label="متن پیام" class="message" />
    <Button type="contained" class="button" size="lg" @click.native="onSubmit" disabled>ارسال</Button>
  </form>
</template>

<script>
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";
import TextArea from "@/components/base/TextArea";

export default {
  name: "ContactForm",
  components: {
    TextField,
    Button,
    TextArea
  },
  data() {
    return {
      name: "",
      email: '',
      message: ''
    }
  },
  methods: {
    onSubmit(e) {
      e.preventDefault();
      if (this.canSend) {
        const data = {
          name: this.name,
          email: this.email,
          message: this.message
        };
        this.$store.dispatch('contact/sendEmail', {data}).then(response => {
          if (response.status === 200) {
            this.$store.dispatch('notifications/push', {
              message: "پیام شما با موفقیت ارسال شد.",
              type: "success",
              light: true
            });
            this.clearForm();
          } else {
            this.$store.dispatch('notifications/push', {
              message: "ورودی های شما نا معتبر می باشد.",
              type: "error",
            });
          }
        }).catch(e => {
          this.$store.dispatch('notifications/push', {
            message: "خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره تلاش کنید.",
            type: "error",
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: "لطفا ورودی های خود را کنترل کنید.",
          type: "warning",
          light: true
        });
      }
    },
    clearForm() {
      this.name = '';
      this.email = '';
      this.message = '';
    }
  },
  computed: {
    isFormFilled() {
      return this.name && this.email && this.message ? true : false;
    },
    isFormValid() {
      return this.nameError || this.emailError ? false : true;
    },
    canSend() {
      return this.isFormFilled && this.isFormValid ? true : false;
    },
    nameError() {
      const regex = /^[آ-ی ء چ]+$/;
      if (!this.name) {
        return "";
      } else if (!regex.test(this.name)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    emailError() {
      const regex = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      if (!this.email) {
        return "";
      } else if (!regex.test(this.email)) {
        return "ایمیل وارد شده معتبر نمی باشد!";
      } else {
        return "";
      }
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables";

.form
  color $white
  display flex
  flex-direction column
  & > *:not(:last-child)
    margin-bottom $md

.button
  width 100%

.message
  flex-grow 1
</style>